#include "license-server.h"

extern char *optarg;

static void usage()
{
        printf("Usage:\n");
        printf("1.license-gen -h \n");
        printf("        Print help. \n");
#ifndef	LOONGSON_PLATFORM
        printf("2.license-gen -p pid -v vid -u user_num -n node_num -m modules -d days -c customer -f feedback -e expand -t -k\n");
#else
        printf("2.license-gen -i interfaceversion -p pid -v vid -u user_num -n node_num -m modules -d days -c customer -f feedback -e expand -t\n");
#endif
	printf("3.license-gen -V \n");
        printf("        printf the version of license lib.\n");

}


int check_num_arg(char *arg)
{
	int len = strlen(arg);
	int i = 0;
	
	for(i=0;i<len;i++)
	{
		if(*arg<'0' || *arg>'9')
			return 1;
		arg++;
	}

	return 0;
}

int main(int argc, char *argv[])
{
	int opt;
	int i = 0;
	int rv = 0;
	char license_file_name[256];
	char v[16];
	int vlen = 16;
	int intfver = 1;
	int fblen = 0;
	
	cs2c_license_control_info control_info;
	cs2c_license_feedback fb;

	if(argc<2)
	{
		usage();
		return -1;
	}

        if(argv[1][0]!='-')
        {
                usage();
                return -1;
        }


	memset(v,0,16);
	memset(&control_info,0,sizeof(cs2c_license_control_info));	
	memset(&fb,0,sizeof(cs2c_license_feedback));
	memset(license_file_name,0,256);
	strcpy(license_file_name,"license.dat");


#ifndef LOONGSON_PLATFORM
        while ((opt = getopt(argc, argv, "hp:v:u:n:m:d:c:f:e:tkV")) != -1)
#else
        while ((opt = getopt(argc, argv, "hp:i:v:u:n:m:d:c:f:e:tV")) != -1)
#endif
        {

                switch(opt){
                        case '?':
                        case 'h':
                                usage();
                                return 0;
			case 'i':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((u32)atoi(optarg)>((1<<8)-1))
                                {
                                        printf("product id is wrong!0<=pid<=255,but %s is input!\n",optarg);
                                        exit(0);
                                }
				intfver = (u8)atoi(optarg);
                                break;
                        case 'p':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}

				if((u32)atoi(optarg)>((1<<8)-1))
				{
					printf("product id is wrong!0<=pid<=255,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.pid = (u8)atoi(optarg);
                                break;
                        case 'v':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((u32)atoi(optarg)>((1<<8)-1))
				{
					printf("version id is wrong!0<=vid<=255,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.vid = (u8)atoi(optarg);
                                break;
                        case 'u':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((u32)atoi(optarg)>((1<<16)-1))
				{
					printf("user number is wrong!0<=unum<=65535,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.user_num = (u16)atoi(optarg);
                                break;
                        case 'n':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((u32)atoi(optarg)>((1<<16)-1))
				{
					printf("node number is wrong!0<=nnum<=65535,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.node_num = (u16)atoi(optarg);
                                break;
                        case 'm':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((long long)atoll(optarg)>=(long long)4294967296llu)
				{
					printf("modules number is wrong!0<=modules<=4294967295,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.modules = (u32)atoll(optarg);
                                break;
                        case 'd':
				if(check_num_arg(optarg))
				{
					printf("please input a decimal number!\n");
					return -1;
				}
				if((u32)atoi(optarg)>((1<<16)-1))
				{
					printf("date setting is wrong!!days>=0,days<=65535,but %s is input!\n",optarg);
					exit(0);
				}
				control_info.days = (u32)atoi(optarg);
                                break;
			case 'c':
				if(strlen(optarg)>79)
				{
					printf("customer length is too long which should not be bigger than 79!\n");
					exit(0);
				}
				strcpy(fb.customer,optarg);
				break;
			case 'f':
				/*if(strlen(optarg)!=33)*/
				fblen = strlen(optarg);
				if(( fblen != FB_LENGTH) && (fblen != FB_LENGTH_V2))
				{
					printf("feedback string length error!%d\n",strlen(optarg));
					exit(0);
				}
				strcpy(fb.feedback,optarg);
				break;
			case 'e':
				if(strlen(optarg)>16)
				{
					printf("expand string is too long which should not be bigger than 16!\n");
					exit(0);
				}
				strcpy(fb.expand,optarg);
				break;
			case 't':
				control_info.iftry = 1;
				break;
#ifndef	LONNGSON_PLATFOPM
			case 'k':
				fb.ifukey = 1;
				break;
#endif
                        case 'V':
                                license_get_lib_version(v,&vlen);
                                printf("%s\n",v);
                                exit(0);
                        default:
                                break;
                }
        }

/*	
        printf("control_info->pid = %d\n",control_info.pid);
        printf("control_info->vid = %d\n",control_info.vid);
        printf("control_info->user_num = %d\n",control_info.user_num);
        printf("control_info->node_num = %d\n",control_info.node_num);
        printf("control_info->iftry = %d\n",control_info.iftry);
        printf("control_info->ifukey = %d\n",control_info.ifukey);
        printf("control_info->days = %d\n",control_info.days);
        printf("control_info->customer = %s\n",control_info.customer);
        printf("control_info->feedback = %s\n",control_info.feedback);
        printf("control_info->expand = %s\n",control_info.expand);
*/
	/*for(i=0;i<34;i++)*/
	for(i=0;i < fblen;i++)
	{
		if(fb.feedback[i]!=0)
			break;
	}

	if(i==fblen){

			printf("Please input a feedback!\n");
			return 0;
	}

/*	if (intfver == 2){
		rv = 
	} */
	rv = license_gen(&control_info,1,&fb);
	if(rv == 0)
		printf("%s generated succeed!\n",license_file_name);
	else {
		printf("license generated failed!\n");	
		print_license_err(rv);	
	}
	return 0;
}
